# petstore

Petstore - the Ruby gem for the OpenAPI Petstore

This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\

This SDK is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build petstore.gemspec
```

Then either install the gem locally:

```shell
gem install ./petstore-1.0.0.gem
```

(for development, run `gem install --dev ./petstore-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'petstore', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'petstore', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:

```ruby
# Load the gem
require 'petstore'

api_instance = Petstore::AnotherFakeApi.new
client = Petstore::Client.new # Client | client model

begin
  #To test special tags
  result = api_instance.call_123_test_special_tags(client)
  p result
rescue Petstore::ApiError => e
  puts "Exception when calling AnotherFakeApi->call_123_test_special_tags: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *http://petstore.swagger.io:80/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Petstore::AnotherFakeApi* | [**call_123_test_special_tags**](docs/AnotherFakeApi.md#call_123_test_special_tags) | **PATCH** /another-fake/dummy | To test special tags
*Petstore::DefaultApi* | [**foo_get**](docs/DefaultApi.md#foo_get) | **GET** /foo | 
*Petstore::FakeApi* | [**fake_health_get**](docs/FakeApi.md#fake_health_get) | **GET** /fake/health | Health check endpoint
*Petstore::FakeApi* | [**fake_http_signature_test**](docs/FakeApi.md#fake_http_signature_test) | **GET** /fake/http-signature-test | test http signature authentication
*Petstore::FakeApi* | [**fake_outer_boolean_serialize**](docs/FakeApi.md#fake_outer_boolean_serialize) | **POST** /fake/outer/boolean | 
*Petstore::FakeApi* | [**fake_outer_composite_serialize**](docs/FakeApi.md#fake_outer_composite_serialize) | **POST** /fake/outer/composite | 
*Petstore::FakeApi* | [**fake_outer_number_serialize**](docs/FakeApi.md#fake_outer_number_serialize) | **POST** /fake/outer/number | 
*Petstore::FakeApi* | [**fake_outer_string_serialize**](docs/FakeApi.md#fake_outer_string_serialize) | **POST** /fake/outer/string | 
*Petstore::FakeApi* | [**fake_property_enum_integer_serialize**](docs/FakeApi.md#fake_property_enum_integer_serialize) | **POST** /fake/property/enum-int | 
*Petstore::FakeApi* | [**test_body_with_binary**](docs/FakeApi.md#test_body_with_binary) | **PUT** /fake/body-with-binary | 
*Petstore::FakeApi* | [**test_body_with_file_schema**](docs/FakeApi.md#test_body_with_file_schema) | **PUT** /fake/body-with-file-schema | 
*Petstore::FakeApi* | [**test_body_with_query_params**](docs/FakeApi.md#test_body_with_query_params) | **PUT** /fake/body-with-query-params | 
*Petstore::FakeApi* | [**test_client_model**](docs/FakeApi.md#test_client_model) | **PATCH** /fake | To test \"client\" model
*Petstore::FakeApi* | [**test_endpoint_parameters**](docs/FakeApi.md#test_endpoint_parameters) | **POST** /fake | Fake endpoint for testing various parameters 假端點 偽のエンドポイント 가짜 엔드 포인트 
*Petstore::FakeApi* | [**test_enum_parameters**](docs/FakeApi.md#test_enum_parameters) | **GET** /fake | To test enum parameters
*Petstore::FakeApi* | [**test_group_parameters**](docs/FakeApi.md#test_group_parameters) | **DELETE** /fake | Fake endpoint to test group parameters (optional)
*Petstore::FakeApi* | [**test_inline_additional_properties**](docs/FakeApi.md#test_inline_additional_properties) | **POST** /fake/inline-additionalProperties | test inline additionalProperties
*Petstore::FakeApi* | [**test_json_form_data**](docs/FakeApi.md#test_json_form_data) | **GET** /fake/jsonFormData | test json serialization of form data
*Petstore::FakeApi* | [**test_query_parameter_collection_format**](docs/FakeApi.md#test_query_parameter_collection_format) | **PUT** /fake/test-query-parameters | 
*Petstore::FakeClassnameTags123Api* | [**test_classname**](docs/FakeClassnameTags123Api.md#test_classname) | **PATCH** /fake_classname_test | To test class name in snake case
*Petstore::PetApi* | [**add_pet**](docs/PetApi.md#add_pet) | **POST** /pet | Add a new pet to the store
*Petstore::PetApi* | [**delete_pet**](docs/PetApi.md#delete_pet) | **DELETE** /pet/{petId} | Deletes a pet
*Petstore::PetApi* | [**find_pets_by_status**](docs/PetApi.md#find_pets_by_status) | **GET** /pet/findByStatus | Finds Pets by status
*Petstore::PetApi* | [**find_pets_by_tags**](docs/PetApi.md#find_pets_by_tags) | **GET** /pet/findByTags | Finds Pets by tags
*Petstore::PetApi* | [**get_pet_by_id**](docs/PetApi.md#get_pet_by_id) | **GET** /pet/{petId} | Find pet by ID
*Petstore::PetApi* | [**update_pet**](docs/PetApi.md#update_pet) | **PUT** /pet | Update an existing pet
*Petstore::PetApi* | [**update_pet_with_form**](docs/PetApi.md#update_pet_with_form) | **POST** /pet/{petId} | Updates a pet in the store with form data
*Petstore::PetApi* | [**upload_file**](docs/PetApi.md#upload_file) | **POST** /pet/{petId}/uploadImage | uploads an image
*Petstore::PetApi* | [**upload_file_with_required_file**](docs/PetApi.md#upload_file_with_required_file) | **POST** /fake/{petId}/uploadImageWithRequiredFile | uploads an image (required)
*Petstore::StoreApi* | [**delete_order**](docs/StoreApi.md#delete_order) | **DELETE** /store/order/{order_id} | Delete purchase order by ID
*Petstore::StoreApi* | [**get_inventory**](docs/StoreApi.md#get_inventory) | **GET** /store/inventory | Returns pet inventories by status
*Petstore::StoreApi* | [**get_order_by_id**](docs/StoreApi.md#get_order_by_id) | **GET** /store/order/{order_id} | Find purchase order by ID
*Petstore::StoreApi* | [**place_order**](docs/StoreApi.md#place_order) | **POST** /store/order | Place an order for a pet
*Petstore::UserApi* | [**create_user**](docs/UserApi.md#create_user) | **POST** /user | Create user
*Petstore::UserApi* | [**create_users_with_array_input**](docs/UserApi.md#create_users_with_array_input) | **POST** /user/createWithArray | Creates list of users with given input array
*Petstore::UserApi* | [**create_users_with_list_input**](docs/UserApi.md#create_users_with_list_input) | **POST** /user/createWithList | Creates list of users with given input array
*Petstore::UserApi* | [**delete_user**](docs/UserApi.md#delete_user) | **DELETE** /user/{username} | Delete user
*Petstore::UserApi* | [**get_user_by_name**](docs/UserApi.md#get_user_by_name) | **GET** /user/{username} | Get user by user name
*Petstore::UserApi* | [**login_user**](docs/UserApi.md#login_user) | **GET** /user/login | Logs user into the system
*Petstore::UserApi* | [**logout_user**](docs/UserApi.md#logout_user) | **GET** /user/logout | Logs out current logged in user session
*Petstore::UserApi* | [**update_user**](docs/UserApi.md#update_user) | **PUT** /user/{username} | Updated user


## Documentation for Models

 - [Petstore::AdditionalPropertiesClass](docs/AdditionalPropertiesClass.md)
 - [Petstore::AllOfWithSingleRef](docs/AllOfWithSingleRef.md)
 - [Petstore::Animal](docs/Animal.md)
 - [Petstore::ApiResponse](docs/ApiResponse.md)
 - [Petstore::ArrayOfArrayOfNumberOnly](docs/ArrayOfArrayOfNumberOnly.md)
 - [Petstore::ArrayOfNumberOnly](docs/ArrayOfNumberOnly.md)
 - [Petstore::ArrayTest](docs/ArrayTest.md)
 - [Petstore::Capitalization](docs/Capitalization.md)
 - [Petstore::Cat](docs/Cat.md)
 - [Petstore::CatAllOf](docs/CatAllOf.md)
 - [Petstore::Category](docs/Category.md)
 - [Petstore::ClassModel](docs/ClassModel.md)
 - [Petstore::Client](docs/Client.md)
 - [Petstore::DeprecatedObject](docs/DeprecatedObject.md)
 - [Petstore::Dog](docs/Dog.md)
 - [Petstore::DogAllOf](docs/DogAllOf.md)
 - [Petstore::EnumArrays](docs/EnumArrays.md)
 - [Petstore::EnumClass](docs/EnumClass.md)
 - [Petstore::EnumTest](docs/EnumTest.md)
 - [Petstore::File](docs/File.md)
 - [Petstore::FileSchemaTestClass](docs/FileSchemaTestClass.md)
 - [Petstore::Foo](docs/Foo.md)
 - [Petstore::FormatTest](docs/FormatTest.md)
 - [Petstore::HasOnlyReadOnly](docs/HasOnlyReadOnly.md)
 - [Petstore::HealthCheckResult](docs/HealthCheckResult.md)
 - [Petstore::InlineResponseDefault](docs/InlineResponseDefault.md)
 - [Petstore::List](docs/List.md)
 - [Petstore::MapTest](docs/MapTest.md)
 - [Petstore::MixedPropertiesAndAdditionalPropertiesClass](docs/MixedPropertiesAndAdditionalPropertiesClass.md)
 - [Petstore::Model200Response](docs/Model200Response.md)
 - [Petstore::ModelReturn](docs/ModelReturn.md)
 - [Petstore::Name](docs/Name.md)
 - [Petstore::NullableClass](docs/NullableClass.md)
 - [Petstore::NumberOnly](docs/NumberOnly.md)
 - [Petstore::ObjectWithDeprecatedFields](docs/ObjectWithDeprecatedFields.md)
 - [Petstore::Order](docs/Order.md)
 - [Petstore::OuterComposite](docs/OuterComposite.md)
 - [Petstore::OuterEnum](docs/OuterEnum.md)
 - [Petstore::OuterEnumDefaultValue](docs/OuterEnumDefaultValue.md)
 - [Petstore::OuterEnumInteger](docs/OuterEnumInteger.md)
 - [Petstore::OuterEnumIntegerDefaultValue](docs/OuterEnumIntegerDefaultValue.md)
 - [Petstore::OuterObjectWithEnumProperty](docs/OuterObjectWithEnumProperty.md)
 - [Petstore::Pet](docs/Pet.md)
 - [Petstore::ReadOnlyFirst](docs/ReadOnlyFirst.md)
 - [Petstore::SingleRefType](docs/SingleRefType.md)
 - [Petstore::SpecialModelName](docs/SpecialModelName.md)
 - [Petstore::Tag](docs/Tag.md)
 - [Petstore::User](docs/User.md)


## Documentation for Authorization


### api_key


- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

### api_key_query


- **Type**: API key
- **API key parameter name**: api_key_query
- **Location**: URL query string

### bearer_test

- **Type**: Bearer authentication (JWT)

### http_basic_test

- **Type**: HTTP basic authentication

### http_signature_test


### petstore_auth


- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/api/oauth/dialog
- **Scopes**: 
  - write:pets: modify pets in your account
  - read:pets: read your pets

