# coding: utf-8

"""
    OpenAPI Petstore

    This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import unittest

import petstore_api
from petstore_api.model.cat import Cat
from petstore_api.model.dog import Dog
from petstore_api.model.animal import Animal
from petstore_api.schemas import StrSchema, BoolSchema, frozendict


class TestAnimal(unittest.TestCase):
    """Animal unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def testAnimal(self):
        """Test Animal"""

        regex_err = (
            r"Invalid discriminator value was passed in to Animal.className "
            r"Only the values \['Cat', 'Dog'\] are allowed at \('args\[0\]', 'className'\)"
        )
        with self.assertRaisesRegex(petstore_api.ApiValueError, regex_err):
            Animal(className='Fox', color='red')

        animal = Animal(className='Cat', color='black')
        assert isinstance(animal, Animal)
        assert isinstance(animal, frozendict)
        assert isinstance(animal, Cat)
        assert isinstance(animal, Cat._composed_schemas['allOf'][1])
        assert set(animal.keys()) == {'className', 'color'}
        assert animal.className == 'Cat'
        assert animal.color == 'black'
        assert animal.__class__.color is StrSchema
        assert animal.__class__.className is StrSchema

        # pass in optional param
        animal = Animal(className='Cat', color='black', declawed=True)
        assert isinstance(animal, Animal)
        assert isinstance(animal, frozendict)
        assert isinstance(animal, Cat)
        assert isinstance(animal, Cat._composed_schemas['allOf'][1])
        assert set(animal.keys()) == {'className', 'color', 'declawed'}
        assert animal.className == 'Cat'
        assert animal.color == 'black'
        assert bool(animal.declawed) is True
        assert animal.__class__.color is StrSchema
        assert animal.__class__.className is StrSchema
        assert animal.__class__.declawed is BoolSchema

        # make a Dog
        animal = Animal(className='Dog', color='black')
        assert isinstance(animal, Animal)
        assert isinstance(animal, frozendict)
        assert isinstance(animal, Dog)
        assert isinstance(animal, Dog._composed_schemas['allOf'][1])
        assert set(animal.keys()) == {'className', 'color'}
        assert animal.className == 'Dog'
        assert animal.color == 'black'
        assert animal.__class__.color is StrSchema
        assert animal.__class__.className is StrSchema

        # pass in optional param
        animal = Animal(className='Dog', color='black', breed='Labrador')
        assert isinstance(animal, Animal)
        assert isinstance(animal, frozendict)
        assert isinstance(animal, Dog)
        assert isinstance(animal, Dog._composed_schemas['allOf'][1])
        assert set(animal.keys()) == {'className', 'color', 'breed'}
        assert animal.className == 'Dog'
        assert animal.color == 'black'
        assert animal.breed == 'Labrador'
        assert animal.__class__.color is StrSchema
        assert animal.__class__.className is StrSchema
        assert animal.__class__.breed is StrSchema


if __name__ == '__main__':
    unittest.main()
